SystemOrganization addCategory: #'AL-Tests-Http'!

TestCase subclass: #ALConnectionTest
	instanceVariableNames: 'connection handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-Http'!

!ALConnectionTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/24/2011 21:59'!
handleRequest: aRequest
	^ handler value: aRequest! !

!ALConnectionTest methodsFor: 'support' stamp: 'cwp 3/20/2011 21:45'!
onRequest: aBlock
	| count |
	count := 0.
	handler := 
		[:request |
		count := count + 1.
		aBlock value: request].
	connection handleRequest.
	self assert: count > 0! !

!ALConnectionTest methodsFor: 'data' stamp: 'cwp 4/5/2011 20:24'!
request
	^ ByteArray new writing
		write: 'GET /griffle/plonk HTTP/1.1'; cr; lf;
		write: 'Host: localhost:8001'; cr; lf;
		write: 'Connection: keep-alive'; cr; lf;
		write: 'User-Agent: SUnit Test'; cr; lf;
		write: 'Accept: text/html;q=0.9,text/plain;q=0.8,image/png,*/*;q=0.5'; cr; lf;
		write: 'Accept-Encoding: gzip,deflate,sdch'; cr; lf;
		write: 'Accept-Language: en-US,en;q=0.8'; cr; lf;
		write: 'Accept-Charset: ISO-8859-1,utf-8;q=0.7,*;q=0.3'; cr; lf;
		cr; lf;
		conclusion! !

!ALConnectionTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/24/2011 22:00'!
testParseChromeRequest

	connection := ALConnection 
		in: self request reading 
		out: ByteArray new writing
		handler: self.
	self onRequest:
		[:request |
		self assert: request isMethodGet.
		self assert: request path = (ALPath / 'griffle' / 'plonk').
		self assert: request isConnectionKeepAlive.
		self thisIsATest]! !

!ALConnectionTest methodsFor: 'support' stamp: 'cwp 4/24/2011 22:00'!
thisIsATest
	^ ALResponse status: 204 reason: 'This is a test'.! !

TestCase subclass: #ALRequestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-Http'!

!ALRequestTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/24/2011 20:48'!
testCreation
	| request |
	request := ALRequest method: 'GET' path: ALPath root.
	self assert: request method = 'GET'.
	self assert: request path = ALPath root.
	self assert: request version = 1.1s1.! !

TestCase subclass: #ALResponseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-Http'!

!ALResponseTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/24/2011 22:15'!
testCreation
	| response |
	response := ALResponse status: 204 reason: 'This is a test'.
	self assert: response status = 204.
	self assert: response reason = 'This is a test'.
	self assert: response version = 1.1s1
! !
